% plotbeta1beta2s
% By Sigurd Hagen Johansen
% Created 02.05.2011

% Import all the 'bifur'-data sets for different 

% Name them:
% bifur002 - for s = 0.002
% bifur01 - for s = 0.01
% bifur03 - for s = 0.03
% bifur1 - for s = 0.1

bifur002 = load('C:\Users\Sigurd\Documents\MATLAB\beta1beta2assym\s002\2011-04-29_bifur_beta1_beta2_s-002.txt');
bifur01 = load('C:\Users\Sigurd\Documents\MATLAB\beta1beta2assym\2011-04-08_bifur_beta1_beta2.txt');
bifur03 = load('C:\Users\Sigurd\Documents\MATLAB\beta1beta2assym\s03\2011-04-28_bifur_beta1_beta2_s-03.txt');
bifur1 = load('C:\Users\Sigurd\Documents\MATLAB\beta1beta2assym\s1\2011-04-28_bifur_beta1_beta2_s-1.txt');

%--------------------------------------------------------------------------
% Prepare to plot the results
%--------------------------------------------------------------------------

% sort bifur002 and add coloumn for the s value

upperrows002 = 0;
lowerrows002 = 0;
bifurupper002 = zeros(upperrows002,3);
bifurlower002 = zeros(lowerrows002,3);

for i= 1:length(bifur002(:,1))
    if bifur002(i,1) > bifur002(i,2)
        lowerrows002 = lowerrows002 + 1;
        bifurlower002(lowerrows002,1:2) = bifur002(i,:);
    elseif bifur002(i,2) > bifur002(i,1)
        upperrows002 = upperrows002 +1;
        bifurupper002(upperrows002,1:2) = bifur002(i,:);
    else
        upperrows002 = upperrows002 +1;
        bifurupper002(upperrows002,1:2) = bifur002(i,:);
        lowerrows002 = lowerrows002 + 1;
        bifurlower002(lowerrows002,1:2) = bifur002(i,:);
    end
end
sortedupper002 = sort(bifurupper002);
sortedlower002 = sort(bifurlower002);
sortedupper002(:,3) = .002;
sortedlower002(:,3) = .002;

% sort bifur01 and add coloumn for the s value

upperrows01 = 0;
lowerrows01 = 0;
bifurupper01 = zeros(upperrows01,3);
bifurlower01 = zeros(lowerrows01,3);

for i= 1:length(bifur01(:,1))
    if bifur01(i,1) > bifur01(i,2)
        lowerrows01 = lowerrows01 + 1;
        bifurlower01(lowerrows01,1:2) = bifur01(i,:);
    elseif bifur01(i,2) > bifur01(i,1)
        upperrows01 = upperrows01 +1;
        bifurupper01(upperrows01,1:2) = bifur01(i,:);
    else
        upperrows01 = upperrows01 +1;
        bifurupper01(upperrows01,1:2) = bifur01(i,:);
        lowerrows01 = lowerrows01 + 1;
        bifurlower01(lowerrows01,1:2) = bifur01(i,:);
    end
end
sortedupper01 = sort(bifurupper01);
sortedlower01 = sort(bifurlower01);
sortedupper01(:,3) = .01;
sortedlower01(:,3) = .01;

% sort bifur03 and add coloumn for the s value

upperrows03 = 0;
lowerrows03 = 0;
bifurupper03 = zeros(upperrows03,3);
bifurlower03 = zeros(lowerrows03,3);

for i= 1:length(bifur03(:,1))
    if bifur03(i,1) > bifur03(i,2)
        lowerrows03 = lowerrows03 + 1;
        bifurlower03(lowerrows03,1:2) = bifur03(i,:);
    elseif bifur03(i,2) > bifur03(i,1)
        upperrows03 = upperrows03 +1;
        bifurupper03(upperrows03,1:2) = bifur03(i,:);
    else
        upperrows03 = upperrows03 +1;
        bifurupper03(upperrows03,1:2) = bifur03(i,:);
        lowerrows03 = lowerrows03 + 1;
        bifurlower03(lowerrows03,1:2) = bifur03(i,:);
    end
end
sortedupper03 = sort(bifurupper03);
sortedlower03 = sort(bifurlower03);
sortedupper03(:,3) = 0.03;
sortedlower03(:,3) = 0.03;

% sort bifur1 and add coloumn for the s value

upperrows1 = 0;
lowerrows1 = 0;
bifurupper1 = zeros(upperrows1,3);
bifurlower1 = zeros(lowerrows1,3);

for i= 1:length(bifur1(:,1))
    if bifur1(i,1) > bifur1(i,2)
        lowerrows1 = lowerrows1 + 1;
        bifurlower1(lowerrows1,1:2) = bifur1(i,:);
    elseif bifur1(i,2) > bifur1(i,1)
        upperrows1 = upperrows1 +1;
        bifurupper1(upperrows1,1:2) = bifur1(i,:);
    else
        upperrows1 = upperrows1 +1;
        bifurupper1(upperrows1,1:2) = bifur1(i,:);
        lowerrows1 = lowerrows1 + 1;
        bifurlower1(lowerrows1,1:2) = bifur1(i,:);
    end
end
sortedupper1 = sort(bifurupper1);
sortedlower1 = sort(bifurlower1);
sortedupper1(:,3) = .1;
sortedlower1(:,3) = .1;

%plot
%2Dplots
%--------------------------------------------------------------------------

f1 = figure;
hold on
p7 = plot(sortedupper1(:,1),sortedupper1(:,2),'k','LineWidth', 1.5);
p8 = plot(sortedlower1(:,1),sortedlower1(:,2),'k','LineWidth', 1.5);
set(gca,    'xscale'    ,'log'      ...
       ,    'yscale'    ,'log'      ...
       ,    'box'       ,'on');
xlabel('\beta_1','FontSize',12)
ylabel('\beta_2','FontSize',12)
set(gcf, 'PaperPositionMode', 'manual');
set(gcf, 'PaperUnits', 'centimeters');
set(gcf, 'PaperPosition', [1 1 7.9 7.55]);
figure(f1);
print -dpng beta1beta2s1.png     % save the current figure as a png
hold off

%--------------------------------------------------------------------------

f03 = figure;
hold on
p5 = plot(sortedupper03(:,1),sortedupper03(:,2),'k','LineWidth', 1.5);
p6 = plot(sortedlower03(:,1),sortedlower03(:,2),'k','LineWidth', 1.5);
set(gca,    'xscale'    ,'log'      ...
       ,    'yscale'    ,'log'      ...
       ,    'box'       ,'on');
xlabel('\beta_1','FontSize',12)
ylabel('\beta_2','FontSize',12)
set(gcf, 'PaperPositionMode', 'manual');
set(gcf, 'PaperUnits', 'centimeters');
set(gcf, 'PaperPosition', [1 1 7.9 7.55]);
figure(f03);
print -dpng beta1beta2s03.png     % save the current figure as a png
hold off

%--------------------------------------------------------------------------

f01 = figure;
hold on
p3 = plot(sortedupper01(:,1),sortedupper01(:,2),'k','LineWidth', 1.5);
p4 = plot(sortedlower01(:,1),sortedlower01(:,2),'k','LineWidth', 1.5);
set(gca,    'xscale'    ,'log'      ...
       ,    'yscale'    ,'log'      ...
       ,    'box'       ,'on');
xlabel('\beta_1','FontSize',12)
ylabel('\beta_2','FontSize',12)
set(gcf, 'PaperPositionMode', 'manual');
set(gcf, 'PaperUnits', 'centimeters');
set(gcf, 'PaperPosition', [1 1 7.9 7.55]);
figure(f01);
print -dpng beta1beta2s01.png     % save the current figure as a png
hold off

%--------------------------------------------------------------------------

f002 = figure;
hold on
p1 = plot(sortedupper002(:,1),sortedupper002(:,2),'k','LineWidth', 1.5);
p2 = plot(sortedlower002(:,1),sortedlower002(:,2),'k','LineWidth', 1.5);
set(gca,    'xscale'    ,'log'      ...
       ,    'yscale'    ,'log'      ...
       ,    'box'       ,'on');
xlabel('\beta_1','FontSize',12)
ylabel('\beta_2','FontSize',12)
set(gcf, 'PaperPositionMode', 'manual');
set(gcf, 'PaperUnits', 'centimeters');
set(gcf, 'PaperPosition', [1 1 7.9 7.55]);
figure(f002);
print -dpng beta1beta2s002.png     % save the current figure as a png
hold off
%--------------------------------------------------------------------------
% 3D plot
%--------------------------------------------------------------------------

f3d = figure;
hold on
p11 = plot3(sortedupper002(:,1),sortedupper002(:,2),sortedupper002(:,3),'k','LineWidth', 1.5);
p12 = plot3(sortedlower002(:,1),sortedlower002(:,2),sortedlower002(:,3),'k','LineWidth', 1.5);
p13 = plot3(sortedupper01(:,1),sortedupper01(:,2),sortedupper01(:,3),'r','LineWidth', 1.5);
p14 = plot3(sortedlower01(:,1),sortedlower01(:,2),sortedlower01(:,3),'r','LineWidth', 1.5);
p15 = plot3(sortedupper03(:,1),sortedupper03(:,2),sortedupper03(:,3),'g','LineWidth', 1.5);
p16 = plot3(sortedlower03(:,1),sortedlower03(:,2),sortedlower03(:,3),'g','LineWidth', 1.5);
p17 = plot3(sortedupper1(:,1),sortedupper1(:,2),sortedupper1(:,3),'b','LineWidth', 1.5);
p18 = plot3(sortedlower1(:,1),sortedlower1(:,2),sortedlower1(:,3),'b','LineWidth', 1.5);
set(gca,    'xscale'    ,'log'      ...
       ,    'yscale'    ,'log'      ...
       ,    'zscale'    ,'log'); 
grid on
scatter(17.5,17.5,0.01,'+r');
legend([p11,p13,p15,p17],{'s = 0.002','s = 0.01','s = 0.03','s = 0.1'},'Location','NorthWest');
xlabel('\beta_1','FontSize',12)
ylabel('\beta_2','FontSize',12)
set(gcf, 'PaperPositionMode', 'manual');
set(gcf, 'PaperUnits', 'centimeters');
set(gcf, 'PaperPosition', [1 1 15 14.1]);
figure(f3d);
print -dpng beta1beta23D.png     % save the current figure as a png
hold off