% beta1beta2rwrthom2
% By Sigurd Hagen Johansen
% Created 27.02.2011 to test simplhom2scan
% Edited 07.04.2011
% Find steady states of the function described in hom2.m with beta2 = in2
% and beta1 = in
%tic
% h = waitbar(0,'Please wait...');

F=@rwrtHOM2beta1beta2s002;
minimum =-4;
maximum = 4;
nsteps = 2;
lim = 1e-7;
ilim = 1e-9;
tol = 1e-7;

%brows = 0;
%B = zeros(brows,5);

% Set the interval for the parameter to be scaned for (beta_2)
instart = 0; % 10^instart
instop = 3; % 10^instop
insteps= 20; % 10^(1/insteps) -> steps per 10^x

% Inital value guess width around previous values
w = 1; % preval*10^(+-width)
s = 2; % # steps on each side of the previous value
% To increase the probability of finding a steady state:
wmod = 2; % if the first search fails the outer inital values will be 10^(w+wmod)
smod = 9; % if the first search fails # steps on each side of the previous value is increased by smod

in =10^(instart);
in2 = in;
A = stestasea(F,minimum,maximum,nsteps,lim,tol,in,in2); % Brute force

%--------------------------------------------------------------------------
% Make a bifurcation scan along the diagonal 
%--------------------------------------------------------------------------

brows = 0;
B = zeros(brows,5);
for a=instart:1/insteps:instop
    in = 10^(a);
    in2 = in;
    A = rwrthom2nextss(F,A,in,in2,w,s,wmod,smod,tol,lim,ilim);
    for h = 1:length(A(:,1))
        brows = brows + 1;
        stab = stabilityss(F,A(h,:),in,in2);
        B(brows,:) = [stab,in,in2]; % Save the solutions with their respective stability in B
    end
end
result=B;
resrows = length(result(:,1));

%--------------------------------------------------------------------------
% Within the bistable region, scan in four directions for stability switch
%--------------------------------------------------------------------------

nrows = 0;
N = zeros(nrows,3);
for j=1:length(B(:,1))
    k=1;
    xx = 1;
    while k<=length(N(:,1))
        if(B(j,4:5) == N(k,1:2))
            xx=0;
            break
        end
        k = k +1;
    end
    if(xx)
        nrows = nrows + 1;
        N(nrows,1:2) = B(j,4:5);
    end
end
for i=1:length(N(:,1))
    nstab = 0;
    for j=1:length(B(:,1))
        if N(i,1)== B(j,4) && N(i,2)==B(j,5) && B(j,3)>1
            nstab = nstab +1;            
        end
    end
    N(i,3)= nstab;
end
bifurrows= 0;
bifur = zeros(bifurrows,2);
for i= 1:(length(N(:,1))-1)
    if N(i,3)~= N(i+1,3)
        bifurrows = bifurrows +1;
        bifur(bifurrows,:)= (N(i,1:2)+N(i+1,1:2))/2;
    end    
end

for i = 1:length(N(:,1))
    if N(i,3)>1
        arows = 0;
        A = zeros(arows,2);
        for j = 1:length(B(:,1))
            if N(i,1) == B(j,4) && N(i,2)== B(j,5)
                arows = arows + 1;
                A(arows,:) = B(j,1:2);
            end
        end
        D = A;
        E = A;
        in = N(i,1);
        a = log(N(i,2))/log(10);
        while a <= instop
            in2 = 10^(a);             
            A = rwrthom2nextss(F,E,in,in2,w,s,wmod,smod,tol,lim,ilim);
            for h = 1:length(A(:,1))
                resrows = resrows + 1;
                stab = stabilityss(F,A(h,:),in,in2);
                result(resrows,:) = [stab,in,in2];
            end
            if length(A(:,1)) < 2
                a = a - (1/insteps);
                while a <= instop
                    in2 = 10^(a);
                    A = rwrthom2nextss(F,E,in,in2,w,s,wmod,smod,tol,lim,ilim);
                    for h = 1:length(A(:,1))
                        resrows = resrows + 1;
                        stab = stabilityss(F,A(h,:),in,in2);
                        result(resrows,:) = [stab,in,in2];
                    end
                    if length(A(:,1)) < 2
                        bifurrows = bifurrows +1;
                        bifur(bifurrows,:) = ((result(resrows,4:5)+result(resrows-1,4:5))/2);
                        break
                    else
                        E=A;
                    end
                    a = a + (1/insteps/10);
                end
                break
            else
                E = A;
            end
            a = a + (1/insteps); %increasing value of in2 from multistable point
        end
        E = D;
        a = log(N(i,2))/log(10);
        while a >= instart
            in2 = 10^(a);            
            A = rwrthom2nextss(F,E,in,in2,w,s,wmod,smod,tol,lim,ilim);
            for h = 1:length(A(:,1))
                resrows = resrows + 1;
                stab = stabilityss(F,A(h,:),in,in2);
                result(resrows,:) = [stab,in,in2];
            end
            if length(A(:,1)) < 2
                a = a + (1/insteps);
                while a >= instart
                    in2 = 10^(a);
                    A = rwrthom2nextss(F,E,in,in2,w,s,wmod,smod,tol,lim,ilim);
                    for h = 1:length(A(:,1))
                        resrows = resrows + 1;
                        stab = stabilityss(F,A(h,:),in,in2);
                        result(resrows,:) = [stab,in,in2];
                    end
                    if length(A(:,1)) < 2
                        bifurrows = bifurrows +1;
                        bifur(bifurrows,:) = ((result(resrows,4:5)+result(resrows-1,4:5))/2);
                        break
                    else
                        E=A;
                    end
                    a = a - (1/insteps/10);
                end
                break
            else
                E = A;
            end
            a = a - (1/insteps); %decreasing value of in2 from multistable point
        end
        E = D;
        in2 = N(i,2);
        a = log(N(i,1))/log(10);
        while a <= instop
            in = 10^(a);            
            A = rwrthom2nextss(F,E,in,in2,w,s,wmod,smod,tol,lim,ilim);
            for h = 1:length(A(:,1))
                resrows = resrows + 1;
                stab = stabilityss(F,A(h,:),in,in2);
                result(resrows,:) = [stab,in,in2];
            end
            if length(A(:,1)) < 2
                a = a - (1/insteps);
                while a <= instop
                    in = 10^(a);
                    A = rwrthom2nextss(F,E,in,in2,w,s,wmod,smod,tol,lim,ilim);
                    for h = 1:length(A(:,1))
                        resrows = resrows + 1;
                        stab = stabilityss(F,A(h,:),in,in2);
                        result(resrows,:) = [stab,in,in2];
                    end
                    if length(A(:,1)) < 2
                        bifurrows = bifurrows +1;
                        bifur(bifurrows,:) = ((result(resrows,4:5)+result(resrows-1,4:5))/2);
                        break
                    else
                        E=A;
                    end
                    a = a + (1/insteps/10);
                end
                break
            else
                E = A;
            end
            a = a + (1/insteps); %increasing value of in
        end
        E = D;
        a = log(N(i,1))/log(10);
        while a >= instart
            in = 10^(a);            
            A = rwrthom2nextss(F,E,in,in2,w,s,wmod,smod,tol,lim,ilim);
            for h = 1:length(A(:,1))
                resrows = resrows + 1;
                stab = stabilityss(F,A(h,:),in,in2);
                result(resrows,:) = [stab,in,in2];
            end
            if length(A(:,1)) < 2
                a = a + (1/insteps);
                while a >= instart
                    in = 10^(a);
                    A = rwrthom2nextss(F,E,in,in2,w,s,wmod,smod,tol,lim,ilim);
                    for h = 1:length(A(:,1))
                        resrows = resrows + 1;
                        stab = stabilityss(F,A(h,:),in,in2);
                        result(resrows,:) = [stab,in,in2];
                    end
                    if length(A(:,1)) < 2
                        bifurrows = bifurrows +1;
                        bifur(bifurrows,:) = ((result(resrows,4:5)+result(resrows-1,4:5))/2);
                        break
                    else
                        E=A;
                    end
                    a = a - (1/insteps/10);
                end
                break
            else
                E = A;
            end
            a = a - (1/insteps); %decreasing value of in2
        end
    end
end

%--------------------------------------------------------------------------
% Prepare to plot the results
%--------------------------------------------------------------------------

birows = 0;
BI = zeros(birows,3);
for j=1:length(result(:,1))
    k=1;
    xx = 1;
    while k<=length(BI(:,1))
        if(result(j,4:5) == BI(k,1:2))
            xx=0;
            break
        end
        k = k +1;
    end
    if(xx)
        birows = birows + 1;
        BI(birows,1:2) = result(j,4:5);
    end 
end

for i=1:length(BI(:,1))
    nstab = 0;
    for j=1:length(result(:,1))
        if BI(i,1)== result(j,4) && BI(i,2)==result(j,5) && result(j,3)>1
            nstab = nstab +1;            
        end
    end
    BI(i,3)= nstab;
end

upperrows = 0;
lowerrows = 0;
bifurupper = zeros(upperrows,2);
bifurlower = zeros(lowerrows,2);

for i= 1:length(bifur(:,1))
    if bifur(i,1) > bifur(i,2)
        lowerrows = lowerrows + 1;
        bifurlower(lowerrows,:) = bifur(i,:);
    elseif bifur(i,2) > bifur(i,1)
        upperrows = upperrows +1;
        bifurupper(upperrows,:) = bifur(i,:);
    else
        upperrows = upperrows +1;
        bifurupper(upperrows,:) = bifur(i,:);
        lowerrows = lowerrows + 1;
        bifurlower(lowerrows,:) = bifur(i,:);
    end
end
sortedupper = sort(bifurupper);
sortedlower = sort(bifurlower);

%--------------------------------------------------------------------------
%Plot the data
%--------------------------------------------------------------------------

% %Phase plot
% for i=1:length(BI(:,1))
%     hold on
%     if BI(i,3)==1
%         scatter(BI(i,1),BI(i,2),'.g')
%     elseif BI(i,3)==2
%         scatter(BI(i,1),BI(i,2),'.r')
%     end
% end
% set(gca,'xscale','log','yscale','log')
% xlabel('\beta_1','FontSize',16)
% ylabel('\beta_2','FontSize',16)
% title('\it{\beta_1 vs \beta_2, s_1 = s_2 = 0.01, K_1 = K_2 = 10, 08.04.2011}','FontSize',16)
% hold off
% 
% % Bifurcation limit plot - scatter
% for i=1:length(bifur(:,1))
%     hold on
%     scatter(bifur(i,1),bifur(i,2),'.k')
% %     scatter(bifur(i,2),bifur(i,1),'.k') % other param symm
% end
% set(gca,'xscale','log','yscale','log')
% xlabel('\beta_1','FontSize',16)
% ylabel('\beta_2','FontSize',16)
% title('\it{\beta_1 vs \beta_2, s_1 = s_2 = 0.01, K_1 = K_2 = 10, 08.04.2011}','FontSize',16)
% hold off
% 
% % Bifurcation limit plot
% f3 = figure; 
% hold on
% p1 = plot(sortedupper(:,1),sortedupper(:,2),'k','LineWidth', 1.5);
% p2 = plot(sortedlower(:,1),sortedlower(:,2),'k','LineWidth', 1.5);
% scatter(17.5,17.5,'+r')
% set(gca,    'xscale'    ,'log'      ...
%     ,    'yscale'    ,'log'      ...
%     ,    'box'       ,'on');
% xlabel('\beta_1','FontSize',12)
% ylabel('\beta_2','FontSize',12)
% set(gcf, 'PaperPositionMode', 'manual');
% set(gcf, 'PaperUnits', 'centimeters');
% set(gcf, 'PaperPosition', [1 1 7.9 7.55]);
% %title('\it{\beta_1 vs \beta_2, s_1 = s_2 = 0.01, K_1 = K_2 = 10, 08.04.2011}','FontSize',16)
% figure(f3);
% print -dpng C:\Users\Sigurd\Dropbox\MASTER\firsted\beta1beta2.png     % save the current figure as a png
% hold off


%---------------------------------------------------------
%Print the results to textfile
%---------------------------------------------------------


[resrows rescols] = size(result);
filename = '2011-04-28_result_p1_p2_stab_beta1_beta2_s-03.txt';
fid = fopen(filename,'w');
for row=1:resrows
    fprintf(fid, '%f %f %f %f %f \n', result(row,:));
end
fclose(fid);

[BIrows BIcols] = size(BI);
filename = '2011-04-28_BI_beta1_beta2_nstab_s-03.txt';
fid = fopen(filename,'w');
for row=1:BIrows
    fprintf(fid, '%f %f %f \n', BI(row,:));
end
fclose(fid);

[bifurrows bifurcols] = size(bifur);
filename = '2011-04-28_bifur_beta1_beta2_s-03.txt';
fid = fopen(filename,'w');
for row=1:bifurrows
    fprintf(fid, '%f %f \n', bifur(row,:));
end
fclose(fid);


% toc

%close(h)