% fullplot
% By Sigurd Hagen Johansen
% 07.05.2011

% Import the data as 'cIon' and 'cIoff'

cIon = importdata('cItetRfullcIon_notetrcoop_gibson-bruck_start-0_stop-100000_respoints-100000_ensize-1');
cIoff = importdata('cItetRfullcIoff_notetrcoop_gibson-bruck_start-0_stop-100000_respoints-100000_ensize-1');
% The colheaders contain:
%   Columns 1 through 6
% 
%     '% time'    ' D1_00'    ' D1_01'    ' D1_10'    ' D1_11'    ' D1_20'
% 
%   Columns 7 through 12
% 
%     ' D1_21'    ' D2_00'    ' D2_01'    ' D2_10'    ' D2_11'    ' D2_20'
% 
%   Columns 13 through 20
% 
%     ' D2_21'    ' E1'    ' E2'    ' M1'    ' M2'    ' RNAp'    ' cI'    ' cI_2'
% 
%   Columns 21 through 22
% 
%     ' tetR'    ' tetR_2'

f1 = figure;
hold on
p1 = plot(cIon(:,1),cIon(:,20),'r'); % plot of cI_2 vs time represented as a red curve
p2 = plot(cIon(:,1),cIon(:,22),'b'); % plot of tetR_2 vs time represented as a blue curve
xlabel('time (s)')
ylabel('number of dimers')
legend('cI_2','TetR_2');
print('-dpng','stochfullcIon.png');
hold off
close(f1);

f2 = figure;
hold on
p3 = plot(cIoff(:,1),cIoff(:,20),'r');% plot of cI_2 vs time represented as a red curve
p4 = plot(cIoff(:,1),cIoff(:,22),'b');% plot of tetR_2 vs time represented as a blue curve
xlabel('time (s)')
ylabel('number of dimers')
legend('cI_2','TetR_2')
print('-dpng','stochfullcIoff.png');
hold off
close(f2);
